package com.jasamedika.medifirst2000.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DaftarPenerimaanService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.MappingKirimDokumenPasienVO;
import com.jasamedika.medifirst2000.vo.StrukBuktiPenerimaanCaraBayarVO;

@RestController
@RequestMapping("/daftar-penerimaan")
public class DaftarPenerimaanController extends LocaleController<StrukBuktiPenerimaanCaraBayarVO> {

	@Autowired
	private DaftarPenerimaanService service;

	private static final Logger LOGGER = LoggerFactory.getLogger(DaftarPenerimaanController.class);

	@RequestMapping(value = "/penerimaan", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public Map<String, Object> getDaftarPenerimaan(
			@RequestParam(value = "idPegawai", required = false) Integer idPegawai,
			@RequestParam(value = "idCaraBayar", required = false) Integer idCaraBayar,
			@RequestParam(value = "idKelTransaksi", required = false) Integer idKelTransaksi,
			@RequestParam(value = "dateStartTglSbm", required = false) String dateStartTglSbm,
			@RequestParam(value = "dateEndTglSbm", required = false) String dateEndTglSbm,
			@RequestParam(value = "dateStartVerif", required = false) String dateStartVerif,
			@RequestParam(value = "dateEndVerif", required = false) String dateEndVerif,
			@RequestParam(value = "dateStartClosing", required = false) String dateStartClosing,
			@RequestParam(value = "dateEndClosing", required = false) String dateEndClosing,
			@RequestParam(value = "status", required = false) String status,
			@RequestParam(value = "noClosing", required = false) String noClosing,
			@RequestParam(value = "noVerifikasi", required = false) String noVerifikasi) {
		Map<String, Object> resultPageMap = service.getDaftarPenerimaan(idPegawai, idCaraBayar, idKelTransaksi,
				dateStartTglSbm, dateEndTglSbm, dateStartVerif, dateEndVerif, dateStartClosing, dateEndClosing, status,
				noClosing, noVerifikasi);

		return resultPageMap;
	}

	@RequestMapping(value = "/save-verifikasi-setoran", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveVerifikasiSetoran(@Valid @RequestBody MappingKirimDokumenPasienVO vo,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = service.saveVerifikasiSetoran(vo);
			if (null != result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
						getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when saveVerifikasiSetoran", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when saveVerifikasiSetoran", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}

	@RequestMapping(value = "/save-closing-verifikasi-setoran", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveClosingVerifikasiSetoran(
			@Valid @RequestBody MappingKirimDokumenPasienVO vo, HttpServletRequest request) {
		try {
			Map<String, Object> result = service.saveClosingVerifikasiSetoran(vo);
			if (null != result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
						getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when saveClosingVerifikasiSetoran", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when saveClosingVerifikasiSetoran", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}

}
